package ca.uwaterloo.crysp.datacollector;


import java.util.ArrayList;

import android.app.Activity;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.HandlerThread;
import android.util.Log;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.TextView;

public class WebActivity extends Activity {
	private WebView webview;
	private boolean isWeb = true;
	private final int REQ_GESTURES = 150;
	static int upCtr= 0, downCtr = 0, leftCtr = 0, rightCtr = 0;
	ArrayList<TouchPoint> points;
	double [] fv = new double[11];
	public static Activity webActivity;
	private SensorManager sensorManager;
    private Sensor accelerometer;
    private Sensor gyro;
    static boolean isSwiping = false; 
    ArrayList<String> sensorReadings;
    MySensorEventListener msl = null;
    SensorHandlerThread sht = null;
    private static int imgCounter = 0;
	String [] imgViews = {
			"<html><head></head><body><img src=\"file:///android_asset/img/cd11.jpg\" width=\"250%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd12.jpg\" width=\"250%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd13.jpg\" width=\"250%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd14.jpg\" width=\"250%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd15.jpg\" width=\"250%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd16.jpg\" width=\"250%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd17.jpg\" width=\"250%\"\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd18.jpg\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd19.jpg\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd20.jpg\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd21.jpg\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd22.jpg\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/cd23.jpg\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/diff_1.png\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/diff_2.png\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/diff_3.png\" width=\"275%\"></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/diff_4.png\" width=\"275%\"></body></html>",
	}; 
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_web);
		
		webActivity = this;
		View view = findViewById(R.id.controls_layout);
		view.setVisibility(View.GONE);
		int [] swipeCounter = ModelStorage.readModelStats(ConfigActivity.user);
		upCtr = swipeCounter[0];
		downCtr = swipeCounter[1];
		leftCtr = swipeCounter[2];
		rightCtr = swipeCounter[3];
		updateCounters();
		
		sensorManager = (SensorManager) getSystemService(this.SENSOR_SERVICE);
        accelerometer = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
        gyro = sensorManager.getDefaultSensor(Sensor.TYPE_GYROSCOPE);
        sensorReadings = new ArrayList<String>();
        if (sht == null)
        	sht = new SensorHandlerThread("SensorHandlerThread");
        msl = new MySensorEventListener(); 
        sensorManager.registerListener(msl, accelerometer , SensorManager.SENSOR_DELAY_FASTEST, sht.handler);
		sensorManager.registerListener(msl, gyro , SensorManager.SENSOR_DELAY_FASTEST, sht.handler);
		
		points = new ArrayList<TouchPoint>();
		webview = (WebView) findViewById(R.id.webView);
		webview.getSettings().setJavaScriptEnabled(true);
		webview.setWebViewClient(new WebViewClient());
		isWeb = true;
		TextView tv = (TextView) findViewById(R.id.view_type);
		tv.setText(" Game ");
		tv.setOnClickListener(viewSwitchHandler);
		tv = (TextView) findViewById(R.id.next_pic);
		tv.setOnClickListener(viewSwitchHandler);
		tv = (TextView) findViewById(R.id.prev_pic);
		tv.setOnClickListener(viewSwitchHandler);
		//View view = findViewById(R.id.controls_layout);
		//view.setVisibility(View.GONE);
		webview.loadUrl("http://www.wikipedia.org/");
		//webview.loadDataWithBaseURL(null, str, "text/html", "utf-8",null);
		
	}
	@Override 
	public void onDestroy() {
		sensorManager.unregisterListener(msl);
		super.onDestroy();
	}
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
	    // Check if the key event was the Back button and if there's history
	    if ((keyCode == KeyEvent.KEYCODE_BACK) && webview.canGoBack()) {
	    	webview.goBack();
	        return true;
	    }
	    // If it wasn't the Back key or there's no web page history, bubble up to the default
	    // system behavior (probably exit the activity)
	    return super.onKeyDown(keyCode, event);
	}
	@Override
	public boolean dispatchTouchEvent(MotionEvent ev) {
		/*if (!sensorRegistered) {
			
			sensorRegistered = true;
		}*/
		if(TouchFeatures.procEvent(ev)) {
			double [] fv = TouchFeatures.getFV();
			if (fv[0] == 0.0)	upCtr++;
			else if (fv[0] == 1.0)	downCtr++;
			else if (fv[0] == 2.0)	leftCtr++; 
			else if (fv[0] == 3.0)	rightCtr++;
			updateCounters();
			ArrayList<TouchPoint> points = TouchFeatures.getTouchPoints();
			ModelStorage.writeModel(ConfigActivity.user, fv, points, sensorReadings);
			sensorReadings.clear();
		}
    	return super.dispatchTouchEvent(ev);
    }
	public static synchronized void setSwiping(boolean b) {
		isSwiping = b;
	}
	public static synchronized boolean swiping() {
		return isSwiping;
	}
	private void nextPic() {
		imgCounter = (++imgCounter == imgViews.length)? imgViews.length-1 : imgCounter;
		reloadPicControls();
		webview.loadDataWithBaseURL(null, imgViews[imgCounter], "text/html", "utf-8",null);
	}
	private void prevPic() {
		imgCounter = (--imgCounter < 0)? 0:imgCounter;
		reloadPicControls();
		webview.loadDataWithBaseURL(null, imgViews[imgCounter], "text/html", "utf-8",null);
	}
	private void reloadPicControls() {
		View view = (View) findViewById(R.id.next_pic); 
		if (imgCounter == imgViews.length-1) 
			view.setVisibility(View.INVISIBLE);
		else
			view.setVisibility(View.VISIBLE);
		view = (View) findViewById(R.id.prev_pic);
		if (imgCounter == 0) 
			view.setVisibility(View.INVISIBLE);
		else
			view.setVisibility(View.VISIBLE);
		
	}
	
	
    private void updateCounters() {
		TextView tv = (TextView) findViewById(R.id.up_swipe_count);
		tv.setText("[Up: " + ((REQ_GESTURES-upCtr) < 0 ? 0:REQ_GESTURES-upCtr) + "] ");
    	//TextView tv = (TextView) findViewById(R.id.down_swipe_count);
		//tv.setText("[Down: " + ((REQ_GESTURES-downCtr) < 0 ? 0:REQ_GESTURES-downCtr) + "] ");
		tv = (TextView) findViewById(R.id.left_swipe_count);
		tv.setText("[Left: " + ((REQ_GESTURES-leftCtr) < 0 ? 0:REQ_GESTURES-leftCtr) + "] ");
		//tv = (TextView) findViewById(R.id.right_swipe_count);
		//tv.setText("[Right: " + ((REQ_GESTURES-rightCtr) < 0 ? 0:REQ_GESTURES-rightCtr) + "] ");
    }
    
    View.OnClickListener viewSwitchHandler = new View.OnClickListener() {
		@Override
		public void onClick(View v) {
			int id = v.getId();
			if (id == R.id.view_type){
				isWeb = !isWeb;
				if (!isWeb) {
					TextView tv = (TextView) findViewById(R.id.view_type);
					tv.setText("Browse ");
					View view = findViewById(R.id.controls_layout);
					view.setVisibility(View.VISIBLE);
					reloadPicControls();
					webview.loadDataWithBaseURL(null, imgViews[imgCounter], "text/html", "utf-8",null);
				}
				else {
					TextView tv = (TextView) findViewById(R.id.view_type);
					tv.setText(" Game ");
					View view = findViewById(R.id.controls_layout);
					view.setVisibility(View.GONE);
					webview.loadUrl("http://www.wikipedia.org/");
					//webview.loadDataWithBaseURL(null, str, "text/html", "utf-8",null);
				}
			}
			else if (id == R.id.prev_pic) 
				prevPic();
			else if (id == R.id.next_pic)
				nextPic();
		}
	};
	
	public class SensorHandlerThread extends HandlerThread{
		private Handler handler;
		
		public SensorHandlerThread(String name) {
			super(name);
			start();
			handler  = new Handler(getLooper());
		}
	}
	 private class MySensorEventListener implements SensorEventListener {
		 @Override
		 public void onSensorChanged(SensorEvent sensorEvent) {
			 if (!swiping())
				 return;
			 Sensor sensor = sensorEvent.sensor;
			 if (sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
				 StringBuilder str = new StringBuilder();
				 str.append("A,");
				 str.append(sensorEvent.timestamp);
				 str.append(",");
				 str.append(sensorEvent.values[0]);
				 str.append(",");
				 str.append(sensorEvent.values[1]);
				 str.append(",");
				 str.append(sensorEvent.values[2]);
				 sensorReadings.add(str.toString());
			 }
			 if (sensor.getType() == Sensor.TYPE_GYROSCOPE) {
				 StringBuilder str = new StringBuilder();
				 str.append("G,");
				 str.append(sensorEvent.timestamp);
				 str.append(",");
				 str.append(sensorEvent.values[0]);
				 str.append(",");
				 str.append(sensorEvent.values[1]);
				 str.append(",");
				 str.append(sensorEvent.values[2]);
				 str.append(";");
				 sensorReadings.add(str.toString());
			 }
		 }

		 @Override
		 public void onAccuracyChanged(Sensor sensor, int accuracy) {
		 }
	    }
}